{************************************************************}
{                   Delphi VCL Extensions                    }
{                                                            }
{                 Basic constants and types                  }
{                                                            }
{      Copyright (c) 2002-2007 SoftGold software company     }
{                                                            }
{************************************************************}
unit sgConsts;
{$INCLUDE SGDXF.INC}

interface

uses
  Windows, Classes, Registry;

const
  //dxf/dwg colors
  clByLayer = $2FFFFFFF;
  clByBlock = $3FFFFFFF;
  // Constants for CAD import (entities)
  DXF_SEC_TABLES	    = 0;
  DXF_SEC_BLOCKS	    = 1;
  DXF_SEC_ENTITIES  	= 2;
  DXF_SEC_LTYPE		    = 3;
  DXF_SEC_LAYERS	    = 4;

  DXF_UNKNOWN	       	= 0;
  DXF_TABLE		        = 1;
  DXF_BLOCK		        = 2;
  DXF_LTYPE	         	= 3;
  DXF_LAYER		        = 4;
  DXF_VERTEX		      = 5;
  DXF_LINE		        = 6;
  DXF_SOLID		        = 7;
  DXF_CIRCLE		      = 8;
  DXF_ARC		          = 9;
  DXF_POLYLINE     		= 10;
  DXF_LWPOLYLINE	    = 11;
  DXF_SPLINE		      = 12;
  DXF_INSERT		      = 13;
  DXF_DIMENSION		    = 14;
  DXF_TEXT		        = 15;
  DXF_MTEXT		        = 16;
  DXF_ATTDEF		      = 17;
  DXF_ELLIPSE		      = 18;
  DXF_POINT		        = 19;
  DXF_3DFACE	      	= 20;
  DXF_HATCH		        = 21;
  DXF_IMAGE_ENT       = 22;
  DXF_ATTRIB		      = 23;

  DXF_BEGIN_POLYLINE = 100;
  DXF_END_POLYLINE   = 101;
  DXF_BEGIN_INSERT   = 102;
  DXF_END_INSERT     = 103;
  DXF_BEGIN_VIEWPORT = 104;
  DXF_END_VIEWPORT   = 105;

  
  // Constants for reading CAD images
  Info_0 = 0;
  Text_1 = 1;
  Name_2 = 2;
  Text_3 = 3;
  Text_4 = 4;
  Text_5 = 5;
  LineTypeName_6 = 6;
  TextFont_7 = 7;
  LayerName_8 = 8;
  VarName_9 = 9;
  XFirst_10 = 10;
  XOther_11 = 11;
  XOther_12 = 12;
  XOther_13 = 13;
  XOther_14 = 14;
  XOther_15 = 15;
  XOther_16 = 16;
  XOther_17 = 17;
  XOther_18 = 18;
  XOther_110 = 110;
  XOther_111 = 111;
  XOther_112 = 112;
  YFirst_20 = 20;
  YOther_21 = 21;
  YOther_22 = 22;
  YOther_23 = 23;
  YOther_24 = 24;
  YOther_25 = 25;
  YOther_26 = 26;
  YOther_27 = 27;
  YOther_28 = 28;
  YOther_120 = 120;
  YOther_121 = 121;
  YOther_122 = 122;
  ZFirst_30 = 30;
  ZOther_31 = 31;
  ZOther_32 = 32;
  ZOther_33 = 33;
  ZOther_34 = 34;
  ZOther_35 = 35;
  ZOther_36 = 36;
  ZOther_37 = 37;
  ZOther_130 = 130;
  ZOther_131 = 131;
  ZOther_132 = 132;
  Elevation_38 = 38;
  TableOfEntity_39 = 39;
  Float_40 = 40;
  Float_41 = 41;
  Float_42 = 42;
  Float_43 = 43;
  Float_44 = 44;
  Float_45 = 45;
  Float_46 = 46;
  Float_47 = 47;
  Float_48 = 48;
  FloatRepeated_49 = 49;
  Float_140 = 140;
  Float_141 = 141;
  Float_142 = 142;
  Float_143 = 143;
  Float_144 = 144;
  Float_145 = 145;
  Float_146 = 146;
  Float_147 = 147;
  Float_148 = 148;
  Float_149 = 149;
  Float_211 = 211;
  Float_221 = 221;
  Float_231 = 231;
  Angle_50 = 50;
  Angle_51 = 51;
  Angle_52 = 52;
  Angle_53 = 53;
  Angle_54 = 54;
  Angle_55 = 55;
  Angle_56 = 56;
  Angle_57 = 57;
  Angle_58 = 58;
  Visible_60 = 60;
  ColorNumber_62 = 62;
  UCSVP_65 = 65;
  EntitysBegin_66 = 66;
  PaperSpace_67 = 67;
  Integer_68 = 68;
  Integer_69 = 69;
  Integer_70 = 70;
  Integer_71 = 71;
  Integer_72 = 72;
  Integer_73 = 73;
  Integer_74 = 74;
  Integer_75 = 75;
  Integer_76 = 76;
  Integer_77 = 77;
  Integer_78 = 78;
  Integer_79 = 79;
  Integer_90 = 90;
  Integer_91 = 91;
  Integer_92 = 92;
  Integer_93 = 93;
  Integer_97 = 97;
  Integer_290 = 290;
  Integer_1070 = 1070;
  Extrusion_210 = 210;
  Extrusion_220 = 220;
  Extrusion_230 = 230;
  String_100 = 100;
  String_310 = 310;
  String_330 = 330;
  String_331 = 331;
  String_340 = 340;
  String_341 = 341;
  Integer_370 = 370;
  String_1000 = 1000;  
  String_1005 = 1005;
  Float_1040 = 1040;

  UserDigit = 23111;

  sgDimensionArrowTypeNames: array [0..19] of string = ('_CLOSEDFILLED',
    '_CLOSEDBLANK', '_CLOSED', '_DOT', '_ARCHITECTURALTICK', '_OBLIQUE',
    '_OPEN', '_ORIGIN', '_ORIGIN2', '_RIGHTANGLE', '_OPEN30', '_DOTSMALL',
    '_DOTBLANK', '_DOTSMALLBLANK', '_BOX', '_BOXFILLED', '_DATUMTRIANGLE',
    '_INTEGRAL', '_USERARROW', '_NONE');

  sByBlock = 'BYBLOCK';
  sByLayer = 'BYLAYER';
  sContinuous = 'CONTINUOUS';
  sModel  = 'Model';
  sLayout = 'Layout1';
  sACADXDataAppName = 'ACAD';
  sActiveVPort = '*ACTIVE';
  sModelSpace  = '*MODEL_SPACE';
  sPaperSpace  = '*PAPER_SPACE';

  sTextStyleStandardName = 'STANDARD';

  // Names of a DXF-entities
  sPolyline = 'Polyline';
  sCircle   = 'Circle';
  sEllipse  = 'Ellipse';
  sHatchEntity   = 'HATCH';
  sPatternSOLID  = 'SOLID';
  sPatternANSI31 = 'ANSI31';// FDiagonal, BDiagonal
  sPatternANSI37 = 'ANSI37';// DiagCross
  sPatternNET    = 'NET';   // Cross
  sPatternLINE   = 'LINE';  // Horizintal, Vertical

  sRedlineLayerName = 'Redline_layer';

  // Default numbers of parts for parsing circle and spline
  iDefaultNumberOfCircleParts = 47;//13;
  iDefaultNumberOfSplineParts = 24;
  iCurrentNumberOfCircleParts: Integer = iDefaultNumberOfCircleParts;
  iCurrentNumberOfSplineParts: Integer = iDefaultNumberOfSplineParts;
  iMinNumberOfCircleParts = 4;

  //Maximum count of the lines in a dotted polyline or curve
  //(if count of lines more then iMaxNumDottedLines we draws solid-polyline)
  iMaxNumDottedLines = 1000;

  //It is necessary for comparison floating-point numbers
  fAccuracy = 0.000001;
  // bad value for all singles
  BadSingValue: Single = -24444444;

  // Windows text height factor
  fWinTextHeightFactor: Extended = 1.6000000000;

  // Windows text Y-offset factor by height
  fWinTextYOffsetFactor: Extended = 0.2700000000;

  // Pi / 180
  fPiDividedBy180: Extended = 0.017453292519943295769236907684886;
  // 180 / Pi
  f180DividedByPi: Extended = 57.295779513082320876798154814105;

  //Lineweight settings
  bLineWeightOn: Boolean = True;
  fLineWeightByLayer: Double = -1.0;
  fLineWeightByBlock: Double = -2.0;
  fLineWeightDefault: Double = -3.0;
  fLineWeightFactor: Single = 1.0;
  sLineWeightFactor = 'LineWeightDispFactor';

  sCorruptedDWGfileHeader: string = 'DWG file header is corrupted';
  sEncryptedByPassword: string = 'Encrypted by password';
  sUnsupportedOldDWGVer: string = 'Unsupported old DWG version ID:';
  sUnsupportedNewDWGVer: string = 'Unsupported new DWG version ID:';
  
var
  bUseSHXFonts: Boolean = False;
  bUseGDIPlusForRastImgRotate: Boolean = False;
  //bUseTTFFonts: Boolean = False;
  bSearchSHXPaths: Boolean = True;
  sDefaultSHXPath: string = '';
  sDefaultSHXFont: string = 'simplex.shx';//'txt.shx';
  sSHXSearchPaths: string = '';
  sgClientRect: TRect = (Left:MaxInt; Top:MaxInt; Right:-MaxInt; Bottom:-MaxInt);
  sgClientRectForSnap: TRect;
  sgVisibleArea: TPoint; //!Snap!

const
  sImpossiblePointerID  = '#';
  sInternalDimension = 'sgDim';
  sFilledArrowForLeader = 'Filled_arrow_for_leader';
  sNewBlockID = '#NewBlockID';

  SMessageAnalysing: string = 'Performing file analysing';
  SMessageCleaning: string = 'Performing file cleaning';
  sLoadFile: string = 'Loading file...';
  sLoadEntities: string = 'Loading entities...';

  // AutoCAD 8-bit colors
  arrDXFtoRGBColors: array [0..255] of Cardinal = (
    $000000, $0000FF, $00FFFF, $00FF00, $FFFF00, $FF0000, $FF00FF, $FFFFFF,
    $808080, $C0C0C0, $0000FF, $7F7FFF, $0000CC, $6666CC, $000099, $4C4C99,
    $00007F, $3F3F7F, $00004C, $26264C, $003FFF, $7F9FFF, $0033CC, $667FCC,
    $002699, $4C5F99, $001F7F, $3F4F7F, $00134C, $262F4C, $007FFF, $7FBFFF,
    $0066CC, $6699CC, $004C99, $4C7299, $003F7F, $3F5F7F, $00264C, $26394C,
    $00BFFF, $7FDFFF, $0099CC, $66B2CC, $007299, $4C8599, $005F7F, $3F6F7F,
    $00394C, $26424C, $00FFFF, $7FFFFF, $00CCCC, $66CCCC, $009999, $4C9999,
    $007F7F, $3F7F7F, $004C4C, $264C4C, $00FFBF, $7FFFDF, $00CC99, $66CCB2,
    $009972, $4C9985, $007F5F, $3F7F6F, $004C39, $264C42, $00FF7F, $7FFFBF,
    $00CC66, $66CC99, $00994C, $4C9972, $007F3F, $3F7F5F, $004C26, $264C39,
    $00FF3F, $7FFF9F, $00CC33, $66CC7F, $009926, $4C995F, $007F1F, $3F7F4F,
    $004C13, $264C2F, $00FF00, $7FFF7F, $00CC00, $66CC66, $009900, $4C994C,
    $007F00, $3F7F3F, $004C00, $264C26, $3FFF00, $9FFF7F, $33CC00, $7FCC66,
    $269900, $5F994C, $1F7F00, $4F7F3F, $134C00, $2F4C26, $7FFF00, $BFFF7F,
    $66CC00, $99CC66, $4C9900, $72994C, $3F7F00, $5F7F3F, $264C00, $394C26,
    $BFFF00, $DFFF7F, $99CC00, $B2CC66, $729900, $85994C, $5F7F00, $6F7F3F,
    $394C00, $424C26, $FFFF00, $FFFF7F, $CCCC00, $CCCC66, $999900, $99994C,
    $7F7F00, $7F7F3F, $4C4C00, $4C4C26, $FFBF00, $FFDF7F, $CC9900, $CCB266,
    $997200, $99854C, $7F5F00, $7F6F3F, $4C3900, $4C4226, $FF7F00, $FFBF7F,
    $CC6600, $CC9966, $994C00, $99724C, $7F3F00, $7F5F3F, $4C2600, $4C3926,
    $FF3F00, $FF9F7F, $CC3300, $CC7F66, $992600, $995F4C, $7F1F00, $7F4F3F,
    $4C1300, $4C2F26, $FF0000, $FF7F7F, $CC0000, $CC6666, $990000, $994C4C,
    $7F0000, $7F3F3F, $4C0000, $4C2626, $FF003F, $FF7F9F, $CC0033, $CC667F,
    $990026, $994C5F, $7F001F, $7F3F4F, $4C0013, $4C262F, $FF007F, $FF7FBF,
    $CC0066, $CC6699, $99004C, $994C72, $7F003F, $7F3F5F, $4C0026, $4C2639,
    $FF00BF, $FF7FDF, $CC0099, $CC66B2, $990072, $994C85, $7F005F, $7F3F6F,
    $4C0039, $4C2642, $FF00FF, $FF7FFF, $CC00CC, $CC66CC, $990099, $994C99,
    $7F007F, $7F3F7F, $4C004C, $4C264C, $BF00FF, $DF7FFF, $9900CC, $B266CC, 
    $720099, $854C99, $5F007F, $6F3F7F, $39004C, $42264C, $7F00FF, $BF7FFF,
    $6600CC, $9966CC, $4C0099, $724C99, $3F007F, $5F3F7F, $26004C, $39264C,
    $3F00FF, $9F7FFF, $3300CC, $7F66CC, $260099, $5F4C99, $1F007F, $4F3F7F,
    $13004C, $2F264C, $333333, $5B5B5B, $848484, $ADADAD, $D6D6D6, $FFFFFF);

  sgDXFLineWeights: array [0..23] of Integer = (0, 5, 9, 13, 15, 18, 20, 25, 30, 35,
    40, 50, 53, 60, 70, 80, 90, 100, 106, 120, 140, 158, 200, 211);
    
// Types
type
  PsgFloat = ^TsgFloat;
  TsgFloat = Double;

  TsgInt64 = record
    Lo: Integer;
    Hi: Integer;
  end;

  PFPoint = ^TFPoint;
  TFPoint = record
  case Integer of
    0: (X, Y, Z: TsgFloat);
    1: (V: array[0..2] of TsgFloat);
  end;

  PF2DPoint = ^TF2DPoint;
  TF2DPoint = record
  case Integer of
    0: (X, Y: TsgFloat);
    1: (V: array[0..1] of TsgFloat);
  end;

  PdxfPoint = ^TdxfPoint;
  TdxfPoint = record
    X,Y,Z: Single;
  end;

  TsgLine = record
    Point1: TFPoint;
    Point2: TFPoint;
  end;

  PFRect = ^TFRect;
  TFRect = record
  case Integer of
    0: (Left, Top, Z1, Right, Bottom, Z2: TsgFloat);
    1: (TopLeft, BottomRight: TFPoint);
  end;

  // Extended CAD data
  PcadExtendedData = ^TcadExtendedData;
  TcadExtendedData = packed record
    Param1: Pointer;// 4 byte field
    { Fields below may be added in future versions }
  end;

  PcadData = ^TcadData;
  TcadData = packed record
    Tag: Word;       // classindex, DXF_LINE, DXF_SOLID etc.
    Count: Word;     // number of child entities
    TickCount: Word;
    Flags: Byte;     // Flags byte
		     // for polylines: low bit <> 0 - is closed
		     // for layers: low bit <> 0 - is invisible
    Style: Byte;     // Style (pen, brush...) - for future versions
    Dimension: Integer;
    DashDots: PFPoint;
    DashDotsCount: Integer;
    Color: Integer;  // Color of entity
    Ticks: Pointer;
    Thickness: TsgFloat;// for future versions
    Rotation: TsgFloat; // Text or block rotation angle
    Layer: PAnsiChar;  // Layer name (only one layer for element)
    Text:  PAnsiChar;  // Pointer to text string
    FontName: PAnsiChar;
    Handle: THandle;
    Undefined1: Integer;
    Undefined2: TsgFloat;// Double
    Undefined3: TsgFloat;// Double
    CADExtendedData: PcadExtendedData;
    Point: TFPoint;   // Coordinates of the first point
    Point1: TFPoint;  // Coordinates of the second point
    Point2: TFPoint;  // Coordinates of the third point
    Point3: TFPoint;  // Coordinates of the fourth point
    case Integer of
    0: (Radius, StartAngle, EndAngle, Ratio: TsgFloat; EntityType: Byte); // for arcs (NOT in DXFEnum)
    1: (Block: THandle; Scale: TFPoint); // for Inserts (NOT in DXFEnum)
    2: (FHeight, FScale, RWidth, RHeight: TsgFloat; HAlign, VAlign: Byte); // for Text
    3: (Points: PFPoint);                // for polylines (in DXFEnum)
  end;

  PdxfData = ^TdxfData;
  TdxfData = packed record
    Tag: Word;       // classindex, DXF_LINE, DXF_SOLID etc.
    Count: Word;     // number of child entities
    TickCount: Word;
    Flags: Byte;     // Flags byte
		     // for polylines: low bit <> 0 - is closed
		     // for layers: low bit <> 0 - is invisible
    Style: Byte;     // Style (pen, brush...) - for future versions
    Dimension: Integer;
    DashDots: PdxfPoint;
    DashDotsCount: Integer;
    Color: Integer;  // Color of entity
    Ticks: Pointer;
    Thickness: Single;// for future versions
    Rotation: Single; // Text or block rotation angle
    Layer: PAnsiChar;  // Layer name (only one layer for element)
    Text:  PAnsiChar;  // Pointer to text string
    FontName: PAnsiChar;
    Handle: THandle;
    CADExtendedData: PcadExtendedData;
    Point: TdxfPoint;   // Coordinates of the first point
    Point1: TdxfPoint;  // Coordinates of the second point
    Point2: TdxfPoint;  // Coordinates of the third point
    Point3: TdxfPoint;  // Coordinates of the fourth point
    case Integer of
    0: (Radius, StartAngle, EndAngle, Ratio: Single; EntityType: Byte); // for arcs (NOT in DXFEnum)
    1: (Block: THandle; Scale: TdxfPoint); // for Inserts (NOT in DXFEnum)
    2: (FHeight, FScale, RWidth, RHeight: Single; HAlign, VAlign: Byte); // for Text
    3: (Points: PdxfPoint);                // for polylines (in DXFEnum)
  end;

  // Axes in 3-Dimensional cartesian coordinates
  TsgAxes = (axisX, axisY, axisZ);                

  // DWG, DXF distance units mode
  TsgDistUnitsMode = (umDrawing, umUser, umAltUser);

  // DWG format version
  TsgDWGVersion = (acR09, acR10, acR11, acR12, acR13, acR14, acR2000, acR2004, acR2007);

  // Numbers are necessary for compatibility with a TBrushStyle
  TsgHatchStyle = (hsSolid, hsPatternData, hsHorizontal, hsVertical, hsFDiagonal,
                  hsBDiagonal, hsCross, hsDiagCross);

  TsgImportMode = (imView, imImport);

  // Style of the CAD-drawing space
  TsgCADSpace = (cs2D, cs3D, csUndefined);

  // CAD drawing border type
  TsgBorderType = (btGlobal, btRatio);

  // CAD drawing border size
  TsgBorderSize = Double;

  TsgGradientType = (gtNone, gtCurved, gtCylinder, gtHemiSpherical, gtLinear,
    gtSpherical, gtInvCurved, gtInvCylinder, gtInvHemiSpherical, gtInvSpherical, gtOther);  

  PFMatrix = ^TFMatrix;
  TFMatrix = array[0..3,0..2] of TsgFloat;

  // Modes of 3D objects intersection
  TIntersectionMode = (imNone, imPoint, imLine, imPlane);

  // Object snap modes
  TObjectSnapMode = (osNone, osAll, osEndPt, osIntersection, osCenter, osCross,
    osInsert, osImmediate, osMiddle, osDisabled);

  // The entities to be drawn
  TsgCADEnities = (ceEntity, cePoint, ceLine, ceSolid, ceCircle, ceArc, ceEllipse,
     cePolyline, ceLWPolyline, ceSpline, ceLeader, ceInsert, ceDimension, ceMText,
     ceText, ceAttdef, ceAttrib, ce3dFace, ceImageEnt, ceViewport, ceRegion,
     ceBody, ce3DSolid, cePattern, ceGradient, ceOle2Frame, cePolyPolygon,
     ceGradientPolygon, ceCurvePolygon, ceHatch, ceACADTable, ceFlatPoly, ceFlatHatch,
     ceXRef, ceProxy, cePath);
  {$IFNDEF SGDEL_6}
  PCardinal = ^Cardinal;
  {$ENDIF}

const
  cnstFPointSize = SizeOf(TFPoint) div SizeOf(Pointer);
  cnstFPointZero: TFPoint = ();
  cnstFPointSingle: TFPoint = (X:1; Y:1; Z:1);
  cnstExtrusion: TFPoint = (X: 0; Y: 0; Z: 1);
  cnstF2DPointZero: TF2DPoint = ();
  cnstBad2DRect: TRect = (Left:$7FFF; Top:$7FFF; Right:-$7FFF; Bottom:-$7FFF);
  cnstBadRect: TFRect = (Left: 1E20; Top: -1E20; Z1: 1E20; Right:-1E20; Bottom: 1E20; Z2: -1E20);
  cnstIdentityMat: TFMatrix = ((1, 0, 0), (0, 1, 0), (0, 0, 1), (0, 0, 0));
  cnstBorderSize: Double = 1 / 8;
  cnstBorderType: TsgBorderType = btRatio;

function BinSearch(List: TList; Comp: TListSortCompare; var Index: Integer; var Param): Boolean;
function Degree(ARadian: Extended): Extended;
procedure ClearList(AList: TList);
procedure ClearRecordList(AList: TList);
procedure ClearRecordListOfList(AListOfList: TList);
procedure ClearListWithNilCheck(List: TList);
function CompareDXFPointByXCoord(Item1, Item2: Pointer): Integer;
function CompareDXFPointByYCoord(Item1, Item2: Pointer): Integer;
function CompareFPointByXCoord(Item1, Item2: Pointer): Integer;
function CompareFPointByYCoord(Item1, Item2: Pointer): Integer;
function ConvToFloatDef(const S: string; const Value: Extended): Extended;
procedure ExpandFRect(var R: TFRect; const P: TFPoint);
function FindAutoCADSHXPaths(APaths: TStringList): Boolean;
procedure FreeList(var AList: TList);
procedure FreeRecordList(var AList: TList);
procedure FreeRecordListOfList(var AListOfList: TList);
function MakeDXFPoint(const X, Y, Z: Single): TdxfPoint;
function MakeFPoint(X, Y, Z: TsgFloat): TFPoint;
function MakeF2DPoint(const X, Y: TsgFloat): TF2DPoint;
function MakeFRect(Left, Top, Z1, Right, Bottom, Z2: TsgFloat): TFRect;
function MakeDXFFromFPoint(const AFPoint: TFPoint): TdxfPoint;
function MakeFPointFromDXF(const AdxfPoint: TdxfPoint): TFPoint;
function MakeRightPath(APath: string): string;
function FloatPoint(X, Y: Extended): TFPoint;
function FloatRect(ALeft, ATop, ARight, ABottom: Extended): TFRect;
function FltPoint3D(X, Y, Z: Extended): TFPoint;
function IdentityMat: TFMatrix;
function IsEqual(const AVal1, AVal2: TsgFloat): Boolean;
function IsEqualPoints(const Point1, Point2: TPoint): Boolean;
function IsEqualFPoints(const Point1, Point2: TFPoint): Boolean;
function IsEqualF2DPoints(const Point1, Point2: TF2DPoint): Boolean;
function TransposeMat(const AMatrix: TFMatrix): TFMatrix;
procedure TransRectCorners(var ARect: TFRect; const AMatrix: TFMatrix);
function IsRotated(const M: TFMatrix): Boolean;
//function MatFromExtr(const P: TFPoint; Angle: Single): TFMatrix;
procedure MatOffset(var M: TFMatrix; const P: TFPoint);
function MatXMat(const A,B: TFMatrix): TFMatrix;
function PtXMat(const P: TFPoint; const M: TFMatrix): TFPoint;
function Radian(Angle: Extended): Extended;
procedure ReplaceAnsi(var S: string; const S1, S2: string);
procedure SortList(AList: PPointerList; ACompareFunc: TListSortCompare;
  ALeftPos, ARightPos: Integer);
function StdMat(const S, P: TFPoint): TFMatrix;
procedure SwapSGFloats(var A, B: TsgFloat);
function Proportional(const XInput, YInput, AOutput: TsgFloat; AOutputIsX : Boolean): TsgFloat; //For internal using
function Min(const A, B: Double): Double;
function Max(const A, B: Double): Double;
function MinI(const A, B: Integer): Integer;
function MaxI(const A, B: Integer): Integer;
function GetIntersectingPoint(const Line1, Line2: TsgLine; var IntersectionMode: TIntersectionMode): TFPoint;
function GetIntresectingRectAndLine(const ARect: TFRect; const ALine: TsgLine; var IntersectionMode: TIntersectionMode): TsgLine;
function MaxTsgFloat: Extended;
function DistanceF(APoint1, APoint2: TFPoint): TsgFloat;
function DistanceI(APoint1, APoint2: TPoint): Double;
procedure SwapInts(var A,B);
{$IFNDEF SGDEL_6}
function WideUpperCase(const S: WideString): WideString;
{$ENDIF}

implementation

uses Math, SysUtils, Graphics;

function BinSearch(List: TList; Comp: TListSortCompare; var Index: Integer; var Param): Boolean;
var
  C,L,R: Integer;
begin
  Result := False;
  Index := 0;
  L := 0;
  R := List.Count;
  while True do
  begin
    Index := (L + R) shr 1;
    if L = R then
      Exit;
    C := Comp(List[Index], @Param);
    Result := C=0;
    if Result then
      Exit;
    if C > 0 then
      R := Index
    else
      L := Index+1;
  end;
end;

function Proportional(const XInput, YInput, AOutput: TsgFloat; AOutputIsX : Boolean): TsgFloat;
begin
  if (XInput = 0)or(YInput = 0) then
  begin
    Result := AOutput;
    Exit;
  end;
  if AOutputIsX then
    Result := YInput * AOutput / XInput
  else
    Result := XInput * AOutput / YInput;
end;

function ConvToFloatDef(const S: string; const Value: Extended): Extended;
var
  E: Integer;
begin
  Val(S, Result, E);
  if E <> 0 then
  begin
    Dec(E);
    Val(Copy(S, 1, E), Result, E);
    if (E <> 0) and (Result = 0) then
      Result := Value;
  end;
end;

procedure ExpandFRect(var R: TFRect; const P: TFPoint);
begin
  if R.Left > P.X then
    R.Left := P.X;
  if R.Top < P.Y then
    R.Top := P.Y;
  if R.Z1 > P.Z then
    R.Z1 := P.Z;
  if R.Right < P.X then
    R.Right := P.X;
  if R.Bottom > P.Y then
    R.Bottom := P.Y;
  if R.Z2 < P.Z then
    R.Z2 := P.Z;
end;

function Degree(ARadian: Extended): Extended;
begin
  Result := ARadian * f180DividedByPi;
end;

function MakeDXFPoint(const X, Y, Z: Single): TdxfPoint;
begin
  Result.X := X;
  Result.Y := Y;
  Result.Z := Z;
end;

function MakeFPoint(X, Y, Z: TsgFloat): TFPoint;
begin
  Result.X := X;
  Result.Y := Y;
  Result.Z := Z;
end;

function MakeF2DPoint(const X, Y: TsgFloat): TF2DPoint;
begin
  Result.X := X;
  Result.Y := Y;
end;

function MakeFRect(Left, Top, Z1, Right, Bottom, Z2: TsgFloat): TFRect;
begin
  Result.Left := Left;
  Result.Top := Top;
  Result.Z1 := Z1;
  Result.Right := Right;
  Result.Bottom := Bottom;
  Result.Z2 := Z2;
end;

function MakeFPointFromDXF(const AdxfPoint: TdxfPoint): TFPoint;
begin
  Result.X := AdxfPoint.X;
  Result.Y := AdxfPoint.Y;
  Result.Z := AdxfPoint.Z;
end;

function MakeDXFFromFPoint(const AFPoint: TFPoint): TdxfPoint;
begin
  Result.X := AFPoint.X;
  Result.Y := AFPoint.Y;
  Result.Z := AFPoint.Z;
end;

function MakeRightPath(APath: string): string;
var
  L: Integer;
begin
  L := Length(APath);
  if L > 0 then
    if APath[L] <> '\' then
      APath := APath + '\';
  Result := APath;
end;

function FloatPoint(X, Y: Extended): TFPoint;
begin
  Result.X := X;
  Result.Y := Y;
  Result.Z := 0;
end;

function FloatRect(ALeft, ATop, ARight, ABottom: Extended): TFRect;
begin
  Result.Left := ALeft;
  Result.Top := ATop;
  Result.Z1 := 0;
  Result.Right := ARight;
  Result.Bottom := ABottom;
  Result.Z2 := 0;
end;

function FltPoint3D(X, Y, Z: Extended): TFPoint;
begin
  Result.X := X;
  Result.Y := Y;
  Result.Z := Z;
end;

function Radian(Angle: Extended): Extended;
begin
  Result := Angle * fPiDividedBy180;
end;

procedure ReplaceAnsi(var S: string; const S1, S2: string);
var
  P, Counter, Len1, Len2: Integer;
  vStr, vStr1: string;
begin
  vStr := Lowercase(S);
  vStr1 := Lowercase(S1);
  Len1 := Length(S1);
  Len2 := Length(S2);
  Counter := 0;
  while True do
  begin
    P := Pos(vStr1, vStr);
    if P = 0 then
      Exit;
    Delete(vStr, 1, P + Len1 - 1);
    Delete(S, P + Counter, Len1);
    Inc(Counter, P);
    if S2 <> '' then
    begin
      Insert(S2, S, Counter);
      Inc(Counter, Len2-1);
    end;
  end;
end;

procedure SwapSGFloats(var A, B: TsgFloat);
var
  C: TsgFloat;
begin
  C := A;
  A := B;
  B := C;
end;

function PtXMat(const P: TFPoint; const M: TFMatrix): TFPoint;
  function Part(I: Integer): Extended;
  begin
    Result := P.X * M[0,I] + P.Y * M[1,I] + P.Z * M[2,I] + M[3,I];
  end;
begin
  Result.X := Part(0);
  Result.Y := Part(1);
  Result.Z := Part(2);
end;

function MatXMat(const A,B: TFMatrix): TFMatrix;
var
  I,J: Integer;
begin
  for I := 0 to 3 do
  begin
    for J := 0 to 2 do
      Result[I,J] := A[I,0] * B[0,J] + A[I,1] * B[1,J] + A[I,2] * B[2,J];
  end;
  for J := 0 to 2 do
    Result[3,J] := Result[3,J] + B[3,J];
end;

function IsRotated(const M: TFMatrix): Boolean;
var
  I,J: Integer;
begin
  Result := False;
  for I := 0 to 2 do
  begin
    for J := 0 to 2 do
    begin
      if I = J then
        Continue;
      Result := Abs(M[I,J]) > fAccuracy;
      if Result then
        Exit;
    end;
  end;
end;

procedure MatOffset(var M: TFMatrix; const P: TFPoint);
begin
  M[3,0] := P.X;
  M[3,1] := P.Y;
  M[3,2] := P.Z;
end;

function StdMat(const S,P: TFPoint): TFMatrix;
begin
  FillChar(Result, SizeOf(Result), 0);
  Result[0,0] := S.X;
  Result[1,1] := S.Y;
  Result[2,2] := S.Z;
  MatOffset(Result,P);
end;

function IdentityMat: TFMatrix;
begin
  FillChar(Result, SizeOf(Result), 0);
  Result[0,0] := 1;
  Result[1,1] := 1;
  Result[2,2] := 1;
end;

function TransposeMat(const AMatrix: TFMatrix): TFMatrix;
begin
  Result[0, 0] := AMatrix[0,0];
  Result[1, 0] := AMatrix[0,1];
  Result[2, 0] := AMatrix[0,2];
  Result[0, 1] := AMatrix[1,0];
  Result[1, 1] := AMatrix[1,1];
  Result[2, 1] := AMatrix[1,2];
  Result[0, 2] := AMatrix[2,0];
  Result[1, 2] := AMatrix[2,1];
  Result[2, 2] := AMatrix[2,2];
  Result[3, 0] := -AMatrix[3,0];
  Result[3, 1] := -AMatrix[3,1];
  Result[3, 2] := -AMatrix[3,2];
end;

procedure TransRectCorners(var ARect: TFRect; const AMatrix: TFMatrix);
var
  R: TFRect;

  procedure ExpR(const X, Y, Z: TsgFloat);
  begin
    ExpandFRect(R, PtXMat(MakeFPoint(X, Y, Z), AMatrix));
  end;

begin
  R := cnstBadRect;
  ExpR(ARect.Left, ARect.Top, ARect.Z1);
  ExpR(ARect.Left, ARect.Top, ARect.Z2);
  ExpR(ARect.Left, ARect.Bottom, ARect.Z1);
  ExpR(ARect.Left, ARect.Bottom, ARect.Z2);
  ExpR(ARect.Right, ARect.Top, ARect.Z1);
  ExpR(ARect.Right, ARect.Top, ARect.Z2);
  ExpR(ARect.Right, ARect.Bottom, ARect.Z1);
  ExpR(ARect.Right, ARect.Bottom, ARect.Z2);
  ARect := R;
end;

{ SortList

  Sorts the list. }
procedure SortList(AList: PPointerList; ACompareFunc: TListSortCompare;
  ALeftPos, ARightPos: Integer);
var
  K, N: Integer;
  PItem, PElem: Pointer;
begin
  repeat
    K := ALeftPos;
    N := ARightPos;
    PItem := AList^[(ALeftPos + ARightPos) shr 1];
    repeat
      while ACompareFunc(AList^[K], PItem) < 0 do
        Inc(K);
      while ACompareFunc(AList^[N], PItem) > 0 do
        Dec(N);
      if K <= N then
      begin
        PElem := AList^[K];
        AList^[K] := AList^[N];
        AList^[N] := PElem;
        Inc(K);
        Dec(N);
      end;
    until (K > N);
    if ALeftPos < N then
      SortList(AList, ACompareFunc, ALeftPos, N);
    ALeftPos := K;
  until (K >= ARightPos);
end;

function CompareDXFPointByXCoord(Item1, Item2: Pointer): Integer;
begin
  if(PdxfPoint(Item1)^.X> PdxfPoint(Item2)^.X) then
    Result := +1
  else if(PdxfPoint(Item1)^.X = PdxfPoint(Item2)^.X) then
    Result := 0
  else
    Result := -1;
end;

function CompareDXFPointByYCoord(Item1, Item2: Pointer): Integer;
begin
  if(PdxfPoint(Item1)^.Y> PdxfPoint(Item2)^.Y) then
    Result := +1
  else if(PdxfPoint(Item1)^.Y = PdxfPoint(Item2)^.Y) then
    Result := 0
  else
    Result := -1;
end;

function CompareFPointByXCoord(Item1, Item2: Pointer): Integer;
begin
  if(PFPoint(Item1)^.X> PFPoint(Item2)^.X) then
    Result := +1
  else if(PFPoint(Item1)^.X = PFPoint(Item2)^.X) then
    Result := 0
  else
    Result := -1;
end;

function CompareFPointByYCoord(Item1, Item2: Pointer): Integer;
begin
  if(PFPoint(Item1)^.Y> PFPoint(Item2)^.Y) then
    Result := +1
  else if(PFPoint(Item1)^.Y = PFPoint(Item2)^.Y) then
    Result := 0
  else
    Result := -1;
end;

procedure ClearList(AList: TList);
var
  I: Integer;
begin
  if AList = nil then
    Exit;
  for I := 0 to AList.Count - 1 do
    TObject(AList[I]).Free;
  AList.Clear;
end;

procedure ClearRecordList(AList: TList);
var
  I: Integer;
begin
  if AList = nil then
    Exit;
  for I := 0 to AList.Count - 1 do
    Dispose(AList[I]);
  AList.Clear;
end;

procedure ClearRecordListOfList(AListOfList: TList);
var
  I, K: Integer;
  vList: TList;
begin
  if AListOfList = nil then
    Exit;
  for I := 0 to AListOfList.Count - 1 do
    if AListOfList[I] <> nil then
    begin
      vList := AListOfList[I];
      for K := 0 to TList(vList).Count - 1 do
        if TList(vList).Items[K] <> nil then
          Dispose(TList(vList).Items[K]);
      TList(vList).Free;
    end;
  AListOfList.Clear;
end;

procedure ClearListWithNilCheck(List: TList);
var
  I: Integer;
begin
  if List = nil then
    Exit;
  for I := 0 to List.Count - 1 do
    if List[I] <> nil then
      TObject(List[I]).Free;
  List.Clear;
end;

procedure FreeList(var AList: TList);
begin
  ClearList(AList);
  if AList <> nil then
    AList.Free;
  AList := nil;
end;

procedure FreeRecordList(var AList: TList);
begin
  ClearRecordList(AList);
  if AList <> nil then
    AList.Free;
  AList := nil;
end;

procedure FreeRecordListOfList(var AListOfList: TList);
begin
  if AListOfList = nil then Exit;
  ClearRecordListOfList(AListOfList);
  if AListOfList <> nil then
    AListOfList.Free;
  AListOfList := nil;
end;

function FindAutoCADSHXPaths(APaths: TStringList): Boolean;
const
  ACADRegPath = 'Software\Autodesk\AutoCAD';
var
  S, vRegPath, vDir: string;
  vStrLst: array[0..3] of TStringList;
  I, J, K, vPos: Integer;
  function GetKeyNames(ANameLst: TStrings; const AValName: string;
    var AValue: string): Boolean;
  var
    vReg: TRegistry;
  begin
    Result := False;
    ANameLst.Clear;
    vReg := TRegistry.Create;
    try
      vReg.RootKey := HKEY_CURRENT_USER;
      if vReg.OpenKey(vRegPath,False) then
      begin
        Result := True;
        vReg.GetKeyNames(ANameLst);
        if (AValName <> '') and vReg.ValueExists(AValName) then
          AValue := vReg.ReadString(AValName)
        else
          AValue := '';
      end;
    finally
      vReg.Free;
    end;
  end;
  function IsSHXInFolder(const AFolder: string): Boolean;
  var
    vSr: TSearchRec;
    S: string;
    vLen: Integer;
  begin
    S := AFolder;
    vLen := Length(S);
    if vLen > 0 then
      if S[vLen] <> '\' then S := S + '\';
    Result := FindFirst(S + '*.shx', faAnyFile, vSr) = 0;
    FindClose(vSr);
  end;

begin
  Result := False;
  if not Assigned(APaths) then Exit;
  for I := 0 to 3 do
    vStrLst[I] := TStringList.Create;
  try
    vRegPath := ACADRegPath;
    GetKeyNames(vStrLst[0], '', S);
    for I := 0 to vStrLst[0].Count - 1 do
    begin
      vRegPath := ACADRegPath + '\' + vStrLst[0][I];
      GetKeyNames(vStrLst[1], '', S);
      for J := 0 to vStrLst[1].Count - 1 do
      begin
        vRegPath := vRegPath + '\' + vStrLst[1][J] + '\Profiles';
        GetKeyNames(vStrLst[2], '', S);
        for K := 0 to vStrLst[2].Count - 1 do
        begin
          vRegPath := vRegPath + '\' + vStrLst[2][K] + '\General';
          GetKeyNames(vStrLst[3], 'ACAD', S);
          while S <> '' do
          begin
            vPos := AnsiPos(';', S);
            if vPos = 0 then Break;
            vDir := Copy(S, 1, vPos - 1);
            if IsSHXInFolder(vDir) then APaths.Add(vDir);
            Delete(S, 1, vPos);
          end;
        end;
      end;
    end;
  finally
    for I := 0 to 3 do
      vStrLst[I].Free;
  end;
  Result := APaths.Count > 0;
end;

function Min(const A, B: Double): Double;
begin
  if A < B then
    Result := A
  else
    Result := B;
end;

function Max(const A, B: Double): Double;
begin
  if A > B then
    Result := A
  else
    Result := B;
end;

function MinI(const A, B: Integer): Integer;
begin
  if A < B then
    Result := A
  else
    Result := B;
end;

function MaxI(const A, B: Integer): Integer;
begin
  if A > B then
    Result := A
  else
    Result := B;
end;

function GetIntersectingPoint(const Line1, Line2: TsgLine; var IntersectionMode: TIntersectionMode): TFPoint;
var
  K1, K2, B1, B2: Double;
begin
  Result := cnstFPointZero;
  IntersectionMode := imPoint;
  if IsEqual(Line1.Point2.X, Line1.Point1.X) then
  begin
    Result.X := Line1.Point2.X;
    if not IsEqual(Line2.Point2.X, Line2.Point1.X) then
    begin
      K2 := (Line2.Point2.Y - Line2.Point1.Y) / (Line2.Point2.X - Line2.Point1.X);
      B2 := Line2.Point1.Y - Line2.Point1.X * K2;
      Result.Y := B2 + Result.X * K2;
    end
    else
      if IsEqual(Line1.Point1.X, Line2.Point1.X) then
        IntersectionMode := imLine
      else
        IntersectionMode := imNone;
  end
  else
  if IsEqual(Line2.Point2.X, Line2.Point1.X) then
  begin
    Result.X := Line2.Point1.X;
    if not IsEqual(Line1.Point2.X, Line1.Point1.X) then
    begin
      K1 := (Line1.Point2.Y - Line1.Point1.Y) / (Line1.Point2.X - Line1.Point1.X);
      B1 := Line1.Point1.Y - Line1.Point1.X * K1;
      Result.Y := B1 + Result.X * K1
    end
    else
      if IsEqual(Line1.Point1.X, Line2.Point1.X) then
        IntersectionMode := imLine
      else
        IntersectionMode := imNone;
  end
  else
  begin
    K2 := (Line2.Point2.Y - Line2.Point1.Y) / (Line2.Point2.X - Line2.Point1.X);
    K1 := (Line1.Point2.Y - Line1.Point1.Y) / (Line1.Point2.X - Line1.Point1.X);
    B1 := Line1.Point1.Y - Line1.Point1.X * K1;
    B2 := Line2.Point1.Y - Line2.Point1.X * K2;
    if not IsEqual(K1, K2) then
    begin
      Result.X := (B2 - B1) / (K1 - K2);
      Result.Y := K1 * Result.X + B1;
    end
    else
      if IsEqual(B1, B2) then
        IntersectionMode := imLine
      else
        IntersectionMode := imNone;
  end;
end;

function GetIntresectingRectAndLine(const ARect: TFRect; const ALine: TsgLine; var IntersectionMode: TIntersectionMode): TsgLine;
var
  vIntersectPt: array[0..3] of TFPoint;
  vRectLine: TsgLine;
  vRect: TFRect;
  I, J: Integer;
  Temp: TFPoint;
  vIM: TIntersectionMode;
  A: TsgFloat;
begin
  vRect := ARect;
  if ARect.Top < ARect.Bottom then
  begin
    vRect.Top := ARect.Bottom;
    vRect.Bottom := ARect.Top;
  end;
  //Left line
  vRectLine.Point1 := vRect.TopLeft;
  vRectLine.Point2.X := vRect.Left;
  vRectLine.Point2.Y := vRect.Bottom;
  vIntersectPt[0] := GetIntersectingPoint(vRectLine, ALine, vIM);
  if (vIM <> imPoint)or
     (vRectLine.Point1.Y < vIntersectPt[0].Y)or(vIntersectPt[0].Y < vRectLine.Point2.Y) then
    vIntersectPt[0].X := MaxTsgFloat;
  //Bottom line
  vRectLine.Point1 := vRectLine.Point2;
  vRectLine.Point2 := vRect.BottomRight;
  vIntersectPt[1] := GetIntersectingPoint(vRectLine, ALine, vIM);
  if (vIM <> imPoint)or
     (vRectLine.Point1.X > vIntersectPt[1].X)or(vIntersectPt[1].X > vRectLine.Point2.X) then
    vIntersectPt[1].X := MaxTsgFloat;
  //Right line
  vRectLine.Point1 := vRectLine.Point2;
  vRectLine.Point2.X := vRect.Right;
  vRectLine.Point2.Y := vRect.Top;
  vIntersectPt[2] := GetIntersectingPoint(vRectLine, ALine, vIM);
  if (vIM <> imPoint)or
     (vRectLine.Point1.Y > vIntersectPt[2].Y)or(vIntersectPt[2].Y > vRectLine.Point2.Y) then
    vIntersectPt[2].X := MaxTsgFloat;
  //Top line
  vRectLine.Point1 := vRectLine.Point2;
  vRectLine.Point2 := vRect.TopLeft;
  vIntersectPt[3] := GetIntersectingPoint(vRectLine, ALine, vIM);
  if (vIM <> imPoint)or
     (vRectLine.Point1.X < vIntersectPt[3].X)or(vIntersectPt[3].X < vRectLine.Point2.X) then
    vIntersectPt[3].X := MaxTsgFloat;
  for I := 0 to 2 do
    for J := 0 to 2 - I do
      if vIntersectPt[J].X > vIntersectPt[J + 1].X then
      begin
        Temp := vIntersectPt[J];
        vIntersectPt[J] := vIntersectPt[J + 1];
        vIntersectPt[J + 1] := Temp;
      end;
  Result.Point1 := vIntersectPt[0];
  I := 1;
  while (Abs(vIntersectPt[0].X - vIntersectPt[I].X) < FAccuracy)and(Abs(vIntersectPt[0].Y - vIntersectPt[I].Y) < FAccuracy)and(I < 3) do
    Inc(I);
  Result.Point2 := vIntersectPt[I];
  A := MaxTsgFloat;
  if (not CompareMem(@Result.Point1.X, @A, SizeOf(Result.Point1.X)))and(not CompareMem(@Result.Point2.X, @A, SizeOf(Result.Point1.X))) then
    IntersectionMode := imLine
  else
    if (not CompareMem(@Result.Point1.X, @A, SizeOf(Result.Point1.X)))and(CompareMem(@Result.Point1.X, @A, SizeOf(Result.Point1.X))) then
      IntersectionMode := imPoint
    else
      IntersectionMode := imNone;
end;

function MaxTsgFloat: Extended;
begin
  case SizeOf(TsgFloat) of
    4: Result := MaxSingle;
    8: Result := MaxDouble;
    10: Result := MaxExtended;
  else
    Result := MaxSingle;
  end;
end;

function DistanceF(APoint1, APoint2: TFPoint): TsgFloat;
begin
  Result := Sqrt(Sqr(APoint2.X - APoint1.X) + Sqr(APoint2.Y - APoint1.Y) + Sqr(APoint2.Z - APoint1.Z));
end;

function DistanceI(APoint1, APoint2: TPoint): Double;
var
  P1X, P2X, P1Y, P2Y: Double;
begin
  P1X := APoint1.X;
  P2X := APoint2.X;
  P1Y := APoint1.Y;
  P2Y := APoint2.Y;
  Result := Sqrt(Sqr(P2X - P1X) + Sqr(P2Y - P1Y));
end;

procedure SwapInts(var A,B);
asm
	MOV	ECX,[EAX]
	XCHG	ECX,[EDX]
	MOV	[EAX],ECX
end;

function IsEqual(const AVal1, AVal2: TsgFloat): Boolean;
begin
  Result := Abs(AVal1 - AVal2) < fAccuracy;
end;

function IsEqualPoints(const Point1, Point2: TPoint): Boolean;
begin
  Result := (Point1.X = Point2.X) and (Point1.Y = Point2.Y);
end;

function IsEqualFPoints(const Point1, Point2: TFPoint): Boolean;
begin
  Result := (Abs(Point1.X - Point2.X) < fAccuracy) and (Abs(Point1.Y - Point2.Y) < fAccuracy) and
    (Abs(Point1.Z - Point2.Z) < fAccuracy);
end;

function IsEqualF2DPoints(const Point1, Point2: TF2DPoint): Boolean;
begin
  Result := (Abs(Point1.X - Point2.X) < fAccuracy) and (Abs(Point1.Y - Point2.Y) < fAccuracy);
end;

{$IFNDEF SGDEL_6}
function WideUpperCase(const S: WideString): WideString;
var
  Len: Integer;
begin
  Len := Length(S);
  SetString(Result, PWideChar(S), Len);
  if Len > 0 then CharUpperBuffW(Pointer(Result), Len);
end;
{$ENDIF}

end.
